/* eslint-disable */
import {
  CallOptions,
  ChannelCredentials,
  Client,
  ClientOptions,
  ClientUnaryCall,
  handleUnaryCall,
  makeGenericClientConstructor,
  Metadata,
  ServiceError,
  UntypedServiceImplementation,
} from "@grpc/grpc-js";
import _m0 from "protobufjs/minimal";
import { LegalPerson } from "../../../../ivms101/ivms101";
import { Certificate } from "../../models/v1beta1/ca";
import {
  BusinessCategory,
  businessCategoryFromJSON,
  businessCategoryToJSON,
  Contacts,
  ServiceState as ServiceState1,
  serviceStateFromJSON,
  serviceStateToJSON,
  TRIXOQuestionnaire,
  VerificationState,
  verificationStateFromJSON,
  verificationStateToJSON,
} from "../../models/v1beta1/models";

export const protobufPackage = "trisa.gds.api.v1beta1";

/**
 * Lookup VASP certification information either by their unique ID or by the domain of
 * the TRISA implementation endpoint, which should be the common name of the certificate.
 * Note that if both id and common name are supplied, ID is prioritized.
 */
export interface LookupRequest {
  /** Unique identifier generated by the directory service, most common lookup field. */
  id: string;
  /**
   * The URL of the directory that registered the VASP. If ommitted, it is assumed
   * that the directory being queried is the registering VASP.
   */
  registeredDirectory: string;
  /**
   * The common name of the certificate, e.g. the domain name of the TRISA endpoint.
   * To use other name fields such as the legal business name, you must use search.
   */
  commonName: string;
}

/**
 * Summary information is given in return for VASP lookups as lookups are primarily
 * intended to facilitate P2P verification and public key exchange.
 * NOTE: only verified VASPs are returned using the lookup RPC.
 */
export interface LookupReply {
  /** If no error is specified, the lookup was successful */
  error:
    | Error
    | undefined;
  /** The uniquely identifying components of the VASP in the directory service */
  id: string;
  registeredDirectory: string;
  commonName: string;
  /** The endpoint to connect to for the TRISA P2P protocol (addr:port) */
  endpoint: string;
  /**
   * Certificate information if the VASP is available and verified. The identity
   * certificate is used to establish mTLS connections, the signing certificate is
   * used on a per-transaction basis.
   */
  identityCertificate: Certificate | undefined;
  signingCertificate:
    | Certificate
    | undefined;
  /** Other VASP information that faciliates P2P exchanges */
  name: string;
  country: string;
  verifiedOn: string;
}

/**
 * Search requests allow a more flexibly field serach to identify a VASP, these requests
 * are primarily used to locate a beneficiary VASP in order to begin the TRISA P2P protocol.
 * NOTE: only verified VASPs are returned using the search RPC.
 */
export interface SearchRequest {
  /**
   * Case insensitive search fields that use OR to perform the lookup. The name field
   * can be the legal, short, or DBA name of the VASP or the common name of
   * certificate issued to that VASP (though in this case, it is better to use the
   * Lookup RPC). The website must be a parseable URL to lookup the VASP with.
   */
  name: string[];
  website: string[];
  /**
   * Search filters to condition the search on. Only VASPs that are in the
   * country(ies) or category(ies) specified are returned.
   */
  country: string[];
  businessCategory: BusinessCategory[];
  vaspCategory: string[];
}

export interface SearchReply {
  /** If no error is specified, the search was successful, even if no results returned. */
  error: Error | undefined;
  results: SearchReply_Result[];
}

export interface SearchReply_Result {
  /** The uniquely identifying components of the VASP in the directory service */
  id: string;
  registeredDirectory: string;
  commonName: string;
  /** Address to connect to the remote VASP on to perform a TRISA request */
  endpoint: string;
}

/**
 * Registration requests are validated that they contain correct information and then
 * are sent through the verification process, creating or updating a VASP as needed.
 */
export interface RegisterRequest {
  /**
   * The legal entity IVMS 101 data for VASP KYC information exchange. This is the
   * IVMS 101 data that should be exchanged in the TRISA P2P protocol as the
   * Originator, Intermediate, or Beneficiary VASP fields. A complete and valid
   * identity record with country of registration is required.
   */
  entity:
    | LegalPerson
    | undefined;
  /** Technical, legal, billing, and administrative contacts for the VASP. */
  contacts:
    | Contacts
    | undefined;
  /**
   * Travel Rule Implementation Endpoint - where other TRISA peers should connect.
   * This should be an addr:port combination, e.g. trisa.vaspbot.net:443
   */
  trisaEndpoint: string;
  /**
   * Common name should be the VASP domain name to issue certificates for, which
   * should match the domain in the trisa_endpoint. If this field is omitted, the
   * common name is inferred from the trisa_endpoint.
   */
  commonName: string;
  /** Business Information */
  website: string;
  businessCategory: BusinessCategory;
  vaspCategories: string[];
  /** Should be a date in YYYY-MM-DD format */
  establishedOn: string;
  /** TRIXO Questionnaire */
  trixo: TRIXOQuestionnaire | undefined;
}

export interface RegisterReply {
  /** If the registration was successful, no error will be returned */
  error:
    | Error
    | undefined;
  /**
   * Unique identifiers for the VASP created by the registration.
   * Use these identifiers for status lookup requests and any follow-on interactions.
   */
  id: string;
  registeredDirectory: string;
  commonName: string;
  /** The verification status of the VASP entity. */
  status: VerificationState;
  message: string;
  /** Used to decrypt the emailed certificates in PKCS 12 format */
  pkcs12password: string;
}

export interface VerifyContactRequest {
  id: string;
  token: string;
}

export interface VerifyContactReply {
  /** If no error is specified, the verification request was successful. */
  error:
    | Error
    | undefined;
  /** The verification status of the VASP entity. */
  status: VerificationState;
  message: string;
}

/**
 * Check on the status of a VASP including its verification status and the service
 * status if the TRISA directory service performs health check monitoring. The same
 * parameters as the Lookup RPC are sent, but note that a TRISA directory service may
 * refuse to return all or part of the status request.
 */
export interface VerificationRequest {
  /** Unique identifier generated by the directory service, most common lookup field. */
  id: string;
  /**
   * The URL of the directory that registered the VASP. If ommitted, it is assumed
   * that the directory being queried is the registering VASP.
   */
  registeredDirectory: string;
  /**
   * The common name of the certificate, e.g. the domain name of the TRISA endpoint.
   * To use other name fields such as the legal business name, you must use search.
   */
  commonName: string;
}

export interface VerificationReply {
  /** Status information */
  verificationStatus: VerificationState;
  serviceStatus: ServiceState1;
  /** Should be an RFC 3339 Timestamp */
  verifiedOn: string;
  /** Should be an RFC 3339 Timestamp */
  firstListed: string;
  /** Should be an RFC 3339 Timestamp */
  lastUpdated: string;
  /** Should be an RFC 3339 Timestamp */
  revokedOn: string;
}

export interface HealthCheck {
  /** The number of failed health checks that proceeded the current check. */
  attempts: number;
  /** The timestamp of the last health check, successful or otherwise. */
  lastCheckedAt: string;
}

export interface ServiceState {
  /**
   * Current service status as defined by the recieving system. The system is obliged
   * to respond with the closest matching status in a best-effort fashion. Alerts will
   * be triggered on service status changes if the system does not respond and the
   * previous system state was not unknown.
   */
  status: ServiceState_Status;
  /** Suggest to the directory service when to check the health status again. */
  notBefore: string;
  notAfter: string;
}

export enum ServiceState_Status {
  UNKNOWN = 0,
  HEALTHY = 1,
  UNHEALTHY = 2,
  DANGER = 3,
  OFFLINE = 4,
  MAINTENANCE = 5,
  UNRECOGNIZED = -1,
}

export function serviceState_StatusFromJSON(object: any): ServiceState_Status {
  switch (object) {
    case 0:
    case "UNKNOWN":
      return ServiceState_Status.UNKNOWN;
    case 1:
    case "HEALTHY":
      return ServiceState_Status.HEALTHY;
    case 2:
    case "UNHEALTHY":
      return ServiceState_Status.UNHEALTHY;
    case 3:
    case "DANGER":
      return ServiceState_Status.DANGER;
    case 4:
    case "OFFLINE":
      return ServiceState_Status.OFFLINE;
    case 5:
    case "MAINTENANCE":
      return ServiceState_Status.MAINTENANCE;
    case -1:
    case "UNRECOGNIZED":
    default:
      return ServiceState_Status.UNRECOGNIZED;
  }
}

export function serviceState_StatusToJSON(object: ServiceState_Status): string {
  switch (object) {
    case ServiceState_Status.UNKNOWN:
      return "UNKNOWN";
    case ServiceState_Status.HEALTHY:
      return "HEALTHY";
    case ServiceState_Status.UNHEALTHY:
      return "UNHEALTHY";
    case ServiceState_Status.DANGER:
      return "DANGER";
    case ServiceState_Status.OFFLINE:
      return "OFFLINE";
    case ServiceState_Status.MAINTENANCE:
      return "MAINTENANCE";
    case ServiceState_Status.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}

export interface Error {
  code: number;
  message: string;
}

function createBaseLookupRequest(): LookupRequest {
  return { id: "", registeredDirectory: "", commonName: "" };
}

export const LookupRequest = {
  encode(message: LookupRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.id !== "") {
      writer.uint32(10).string(message.id);
    }
    if (message.registeredDirectory !== "") {
      writer.uint32(18).string(message.registeredDirectory);
    }
    if (message.commonName !== "") {
      writer.uint32(26).string(message.commonName);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): LookupRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseLookupRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.id = reader.string();
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.registeredDirectory = reader.string();
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.commonName = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): LookupRequest {
    return {
      id: isSet(object.id) ? String(object.id) : "",
      registeredDirectory: isSet(object.registeredDirectory) ? String(object.registeredDirectory) : "",
      commonName: isSet(object.commonName) ? String(object.commonName) : "",
    };
  },

  toJSON(message: LookupRequest): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    message.registeredDirectory !== undefined && (obj.registeredDirectory = message.registeredDirectory);
    message.commonName !== undefined && (obj.commonName = message.commonName);
    return obj;
  },

  create<I extends Exact<DeepPartial<LookupRequest>, I>>(base?: I): LookupRequest {
    return LookupRequest.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<LookupRequest>, I>>(object: I): LookupRequest {
    const message = createBaseLookupRequest();
    message.id = object.id ?? "";
    message.registeredDirectory = object.registeredDirectory ?? "";
    message.commonName = object.commonName ?? "";
    return message;
  },
};

function createBaseLookupReply(): LookupReply {
  return {
    error: undefined,
    id: "",
    registeredDirectory: "",
    commonName: "",
    endpoint: "",
    identityCertificate: undefined,
    signingCertificate: undefined,
    name: "",
    country: "",
    verifiedOn: "",
  };
}

export const LookupReply = {
  encode(message: LookupReply, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.error !== undefined) {
      Error.encode(message.error, writer.uint32(10).fork()).ldelim();
    }
    if (message.id !== "") {
      writer.uint32(18).string(message.id);
    }
    if (message.registeredDirectory !== "") {
      writer.uint32(26).string(message.registeredDirectory);
    }
    if (message.commonName !== "") {
      writer.uint32(34).string(message.commonName);
    }
    if (message.endpoint !== "") {
      writer.uint32(42).string(message.endpoint);
    }
    if (message.identityCertificate !== undefined) {
      Certificate.encode(message.identityCertificate, writer.uint32(50).fork()).ldelim();
    }
    if (message.signingCertificate !== undefined) {
      Certificate.encode(message.signingCertificate, writer.uint32(58).fork()).ldelim();
    }
    if (message.name !== "") {
      writer.uint32(66).string(message.name);
    }
    if (message.country !== "") {
      writer.uint32(74).string(message.country);
    }
    if (message.verifiedOn !== "") {
      writer.uint32(82).string(message.verifiedOn);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): LookupReply {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseLookupReply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.error = Error.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.id = reader.string();
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.registeredDirectory = reader.string();
          continue;
        case 4:
          if (tag != 34) {
            break;
          }

          message.commonName = reader.string();
          continue;
        case 5:
          if (tag != 42) {
            break;
          }

          message.endpoint = reader.string();
          continue;
        case 6:
          if (tag != 50) {
            break;
          }

          message.identityCertificate = Certificate.decode(reader, reader.uint32());
          continue;
        case 7:
          if (tag != 58) {
            break;
          }

          message.signingCertificate = Certificate.decode(reader, reader.uint32());
          continue;
        case 8:
          if (tag != 66) {
            break;
          }

          message.name = reader.string();
          continue;
        case 9:
          if (tag != 74) {
            break;
          }

          message.country = reader.string();
          continue;
        case 10:
          if (tag != 82) {
            break;
          }

          message.verifiedOn = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): LookupReply {
    return {
      error: isSet(object.error) ? Error.fromJSON(object.error) : undefined,
      id: isSet(object.id) ? String(object.id) : "",
      registeredDirectory: isSet(object.registeredDirectory) ? String(object.registeredDirectory) : "",
      commonName: isSet(object.commonName) ? String(object.commonName) : "",
      endpoint: isSet(object.endpoint) ? String(object.endpoint) : "",
      identityCertificate: isSet(object.identityCertificate)
        ? Certificate.fromJSON(object.identityCertificate)
        : undefined,
      signingCertificate: isSet(object.signingCertificate)
        ? Certificate.fromJSON(object.signingCertificate)
        : undefined,
      name: isSet(object.name) ? String(object.name) : "",
      country: isSet(object.country) ? String(object.country) : "",
      verifiedOn: isSet(object.verifiedOn) ? String(object.verifiedOn) : "",
    };
  },

  toJSON(message: LookupReply): unknown {
    const obj: any = {};
    message.error !== undefined && (obj.error = message.error ? Error.toJSON(message.error) : undefined);
    message.id !== undefined && (obj.id = message.id);
    message.registeredDirectory !== undefined && (obj.registeredDirectory = message.registeredDirectory);
    message.commonName !== undefined && (obj.commonName = message.commonName);
    message.endpoint !== undefined && (obj.endpoint = message.endpoint);
    message.identityCertificate !== undefined && (obj.identityCertificate = message.identityCertificate
      ? Certificate.toJSON(message.identityCertificate)
      : undefined);
    message.signingCertificate !== undefined &&
      (obj.signingCertificate = message.signingCertificate
        ? Certificate.toJSON(message.signingCertificate)
        : undefined);
    message.name !== undefined && (obj.name = message.name);
    message.country !== undefined && (obj.country = message.country);
    message.verifiedOn !== undefined && (obj.verifiedOn = message.verifiedOn);
    return obj;
  },

  create<I extends Exact<DeepPartial<LookupReply>, I>>(base?: I): LookupReply {
    return LookupReply.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<LookupReply>, I>>(object: I): LookupReply {
    const message = createBaseLookupReply();
    message.error = (object.error !== undefined && object.error !== null) ? Error.fromPartial(object.error) : undefined;
    message.id = object.id ?? "";
    message.registeredDirectory = object.registeredDirectory ?? "";
    message.commonName = object.commonName ?? "";
    message.endpoint = object.endpoint ?? "";
    message.identityCertificate = (object.identityCertificate !== undefined && object.identityCertificate !== null)
      ? Certificate.fromPartial(object.identityCertificate)
      : undefined;
    message.signingCertificate = (object.signingCertificate !== undefined && object.signingCertificate !== null)
      ? Certificate.fromPartial(object.signingCertificate)
      : undefined;
    message.name = object.name ?? "";
    message.country = object.country ?? "";
    message.verifiedOn = object.verifiedOn ?? "";
    return message;
  },
};

function createBaseSearchRequest(): SearchRequest {
  return { name: [], website: [], country: [], businessCategory: [], vaspCategory: [] };
}

export const SearchRequest = {
  encode(message: SearchRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.name) {
      writer.uint32(10).string(v!);
    }
    for (const v of message.website) {
      writer.uint32(18).string(v!);
    }
    for (const v of message.country) {
      writer.uint32(58).string(v!);
    }
    writer.uint32(66).fork();
    for (const v of message.businessCategory) {
      writer.int32(v);
    }
    writer.ldelim();
    for (const v of message.vaspCategory) {
      writer.uint32(74).string(v!);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SearchRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSearchRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.name.push(reader.string());
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.website.push(reader.string());
          continue;
        case 7:
          if (tag != 58) {
            break;
          }

          message.country.push(reader.string());
          continue;
        case 8:
          if (tag == 64) {
            message.businessCategory.push(reader.int32() as any);
            continue;
          }

          if (tag == 66) {
            const end2 = reader.uint32() + reader.pos;
            while (reader.pos < end2) {
              message.businessCategory.push(reader.int32() as any);
            }

            continue;
          }

          break;
        case 9:
          if (tag != 74) {
            break;
          }

          message.vaspCategory.push(reader.string());
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SearchRequest {
    return {
      name: Array.isArray(object?.name) ? object.name.map((e: any) => String(e)) : [],
      website: Array.isArray(object?.website) ? object.website.map((e: any) => String(e)) : [],
      country: Array.isArray(object?.country) ? object.country.map((e: any) => String(e)) : [],
      businessCategory: Array.isArray(object?.businessCategory)
        ? object.businessCategory.map((e: any) => businessCategoryFromJSON(e))
        : [],
      vaspCategory: Array.isArray(object?.vaspCategory) ? object.vaspCategory.map((e: any) => String(e)) : [],
    };
  },

  toJSON(message: SearchRequest): unknown {
    const obj: any = {};
    if (message.name) {
      obj.name = message.name.map((e) => e);
    } else {
      obj.name = [];
    }
    if (message.website) {
      obj.website = message.website.map((e) => e);
    } else {
      obj.website = [];
    }
    if (message.country) {
      obj.country = message.country.map((e) => e);
    } else {
      obj.country = [];
    }
    if (message.businessCategory) {
      obj.businessCategory = message.businessCategory.map((e) => businessCategoryToJSON(e));
    } else {
      obj.businessCategory = [];
    }
    if (message.vaspCategory) {
      obj.vaspCategory = message.vaspCategory.map((e) => e);
    } else {
      obj.vaspCategory = [];
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<SearchRequest>, I>>(base?: I): SearchRequest {
    return SearchRequest.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<SearchRequest>, I>>(object: I): SearchRequest {
    const message = createBaseSearchRequest();
    message.name = object.name?.map((e) => e) || [];
    message.website = object.website?.map((e) => e) || [];
    message.country = object.country?.map((e) => e) || [];
    message.businessCategory = object.businessCategory?.map((e) => e) || [];
    message.vaspCategory = object.vaspCategory?.map((e) => e) || [];
    return message;
  },
};

function createBaseSearchReply(): SearchReply {
  return { error: undefined, results: [] };
}

export const SearchReply = {
  encode(message: SearchReply, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.error !== undefined) {
      Error.encode(message.error, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.results) {
      SearchReply_Result.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SearchReply {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSearchReply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.error = Error.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.results.push(SearchReply_Result.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SearchReply {
    return {
      error: isSet(object.error) ? Error.fromJSON(object.error) : undefined,
      results: Array.isArray(object?.results) ? object.results.map((e: any) => SearchReply_Result.fromJSON(e)) : [],
    };
  },

  toJSON(message: SearchReply): unknown {
    const obj: any = {};
    message.error !== undefined && (obj.error = message.error ? Error.toJSON(message.error) : undefined);
    if (message.results) {
      obj.results = message.results.map((e) => e ? SearchReply_Result.toJSON(e) : undefined);
    } else {
      obj.results = [];
    }
    return obj;
  },

  create<I extends Exact<DeepPartial<SearchReply>, I>>(base?: I): SearchReply {
    return SearchReply.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<SearchReply>, I>>(object: I): SearchReply {
    const message = createBaseSearchReply();
    message.error = (object.error !== undefined && object.error !== null) ? Error.fromPartial(object.error) : undefined;
    message.results = object.results?.map((e) => SearchReply_Result.fromPartial(e)) || [];
    return message;
  },
};

function createBaseSearchReply_Result(): SearchReply_Result {
  return { id: "", registeredDirectory: "", commonName: "", endpoint: "" };
}

export const SearchReply_Result = {
  encode(message: SearchReply_Result, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.id !== "") {
      writer.uint32(10).string(message.id);
    }
    if (message.registeredDirectory !== "") {
      writer.uint32(18).string(message.registeredDirectory);
    }
    if (message.commonName !== "") {
      writer.uint32(26).string(message.commonName);
    }
    if (message.endpoint !== "") {
      writer.uint32(34).string(message.endpoint);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SearchReply_Result {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSearchReply_Result();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.id = reader.string();
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.registeredDirectory = reader.string();
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.commonName = reader.string();
          continue;
        case 4:
          if (tag != 34) {
            break;
          }

          message.endpoint = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SearchReply_Result {
    return {
      id: isSet(object.id) ? String(object.id) : "",
      registeredDirectory: isSet(object.registeredDirectory) ? String(object.registeredDirectory) : "",
      commonName: isSet(object.commonName) ? String(object.commonName) : "",
      endpoint: isSet(object.endpoint) ? String(object.endpoint) : "",
    };
  },

  toJSON(message: SearchReply_Result): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    message.registeredDirectory !== undefined && (obj.registeredDirectory = message.registeredDirectory);
    message.commonName !== undefined && (obj.commonName = message.commonName);
    message.endpoint !== undefined && (obj.endpoint = message.endpoint);
    return obj;
  },

  create<I extends Exact<DeepPartial<SearchReply_Result>, I>>(base?: I): SearchReply_Result {
    return SearchReply_Result.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<SearchReply_Result>, I>>(object: I): SearchReply_Result {
    const message = createBaseSearchReply_Result();
    message.id = object.id ?? "";
    message.registeredDirectory = object.registeredDirectory ?? "";
    message.commonName = object.commonName ?? "";
    message.endpoint = object.endpoint ?? "";
    return message;
  },
};

function createBaseRegisterRequest(): RegisterRequest {
  return {
    entity: undefined,
    contacts: undefined,
    trisaEndpoint: "",
    commonName: "",
    website: "",
    businessCategory: 0,
    vaspCategories: [],
    establishedOn: "",
    trixo: undefined,
  };
}

export const RegisterRequest = {
  encode(message: RegisterRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.entity !== undefined) {
      LegalPerson.encode(message.entity, writer.uint32(10).fork()).ldelim();
    }
    if (message.contacts !== undefined) {
      Contacts.encode(message.contacts, writer.uint32(18).fork()).ldelim();
    }
    if (message.trisaEndpoint !== "") {
      writer.uint32(26).string(message.trisaEndpoint);
    }
    if (message.commonName !== "") {
      writer.uint32(34).string(message.commonName);
    }
    if (message.website !== "") {
      writer.uint32(42).string(message.website);
    }
    if (message.businessCategory !== 0) {
      writer.uint32(48).int32(message.businessCategory);
    }
    for (const v of message.vaspCategories) {
      writer.uint32(58).string(v!);
    }
    if (message.establishedOn !== "") {
      writer.uint32(66).string(message.establishedOn);
    }
    if (message.trixo !== undefined) {
      TRIXOQuestionnaire.encode(message.trixo, writer.uint32(74).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): RegisterRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRegisterRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.entity = LegalPerson.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.contacts = Contacts.decode(reader, reader.uint32());
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.trisaEndpoint = reader.string();
          continue;
        case 4:
          if (tag != 34) {
            break;
          }

          message.commonName = reader.string();
          continue;
        case 5:
          if (tag != 42) {
            break;
          }

          message.website = reader.string();
          continue;
        case 6:
          if (tag != 48) {
            break;
          }

          message.businessCategory = reader.int32() as any;
          continue;
        case 7:
          if (tag != 58) {
            break;
          }

          message.vaspCategories.push(reader.string());
          continue;
        case 8:
          if (tag != 66) {
            break;
          }

          message.establishedOn = reader.string();
          continue;
        case 9:
          if (tag != 74) {
            break;
          }

          message.trixo = TRIXOQuestionnaire.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): RegisterRequest {
    return {
      entity: isSet(object.entity) ? LegalPerson.fromJSON(object.entity) : undefined,
      contacts: isSet(object.contacts) ? Contacts.fromJSON(object.contacts) : undefined,
      trisaEndpoint: isSet(object.trisaEndpoint) ? String(object.trisaEndpoint) : "",
      commonName: isSet(object.commonName) ? String(object.commonName) : "",
      website: isSet(object.website) ? String(object.website) : "",
      businessCategory: isSet(object.businessCategory) ? businessCategoryFromJSON(object.businessCategory) : 0,
      vaspCategories: Array.isArray(object?.vaspCategories) ? object.vaspCategories.map((e: any) => String(e)) : [],
      establishedOn: isSet(object.establishedOn) ? String(object.establishedOn) : "",
      trixo: isSet(object.trixo) ? TRIXOQuestionnaire.fromJSON(object.trixo) : undefined,
    };
  },

  toJSON(message: RegisterRequest): unknown {
    const obj: any = {};
    message.entity !== undefined && (obj.entity = message.entity ? LegalPerson.toJSON(message.entity) : undefined);
    message.contacts !== undefined && (obj.contacts = message.contacts ? Contacts.toJSON(message.contacts) : undefined);
    message.trisaEndpoint !== undefined && (obj.trisaEndpoint = message.trisaEndpoint);
    message.commonName !== undefined && (obj.commonName = message.commonName);
    message.website !== undefined && (obj.website = message.website);
    message.businessCategory !== undefined && (obj.businessCategory = businessCategoryToJSON(message.businessCategory));
    if (message.vaspCategories) {
      obj.vaspCategories = message.vaspCategories.map((e) => e);
    } else {
      obj.vaspCategories = [];
    }
    message.establishedOn !== undefined && (obj.establishedOn = message.establishedOn);
    message.trixo !== undefined && (obj.trixo = message.trixo ? TRIXOQuestionnaire.toJSON(message.trixo) : undefined);
    return obj;
  },

  create<I extends Exact<DeepPartial<RegisterRequest>, I>>(base?: I): RegisterRequest {
    return RegisterRequest.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<RegisterRequest>, I>>(object: I): RegisterRequest {
    const message = createBaseRegisterRequest();
    message.entity = (object.entity !== undefined && object.entity !== null)
      ? LegalPerson.fromPartial(object.entity)
      : undefined;
    message.contacts = (object.contacts !== undefined && object.contacts !== null)
      ? Contacts.fromPartial(object.contacts)
      : undefined;
    message.trisaEndpoint = object.trisaEndpoint ?? "";
    message.commonName = object.commonName ?? "";
    message.website = object.website ?? "";
    message.businessCategory = object.businessCategory ?? 0;
    message.vaspCategories = object.vaspCategories?.map((e) => e) || [];
    message.establishedOn = object.establishedOn ?? "";
    message.trixo = (object.trixo !== undefined && object.trixo !== null)
      ? TRIXOQuestionnaire.fromPartial(object.trixo)
      : undefined;
    return message;
  },
};

function createBaseRegisterReply(): RegisterReply {
  return {
    error: undefined,
    id: "",
    registeredDirectory: "",
    commonName: "",
    status: 0,
    message: "",
    pkcs12password: "",
  };
}

export const RegisterReply = {
  encode(message: RegisterReply, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.error !== undefined) {
      Error.encode(message.error, writer.uint32(10).fork()).ldelim();
    }
    if (message.id !== "") {
      writer.uint32(18).string(message.id);
    }
    if (message.registeredDirectory !== "") {
      writer.uint32(26).string(message.registeredDirectory);
    }
    if (message.commonName !== "") {
      writer.uint32(34).string(message.commonName);
    }
    if (message.status !== 0) {
      writer.uint32(40).int32(message.status);
    }
    if (message.message !== "") {
      writer.uint32(50).string(message.message);
    }
    if (message.pkcs12password !== "") {
      writer.uint32(58).string(message.pkcs12password);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): RegisterReply {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRegisterReply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.error = Error.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.id = reader.string();
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.registeredDirectory = reader.string();
          continue;
        case 4:
          if (tag != 34) {
            break;
          }

          message.commonName = reader.string();
          continue;
        case 5:
          if (tag != 40) {
            break;
          }

          message.status = reader.int32() as any;
          continue;
        case 6:
          if (tag != 50) {
            break;
          }

          message.message = reader.string();
          continue;
        case 7:
          if (tag != 58) {
            break;
          }

          message.pkcs12password = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): RegisterReply {
    return {
      error: isSet(object.error) ? Error.fromJSON(object.error) : undefined,
      id: isSet(object.id) ? String(object.id) : "",
      registeredDirectory: isSet(object.registeredDirectory) ? String(object.registeredDirectory) : "",
      commonName: isSet(object.commonName) ? String(object.commonName) : "",
      status: isSet(object.status) ? verificationStateFromJSON(object.status) : 0,
      message: isSet(object.message) ? String(object.message) : "",
      pkcs12password: isSet(object.pkcs12password) ? String(object.pkcs12password) : "",
    };
  },

  toJSON(message: RegisterReply): unknown {
    const obj: any = {};
    message.error !== undefined && (obj.error = message.error ? Error.toJSON(message.error) : undefined);
    message.id !== undefined && (obj.id = message.id);
    message.registeredDirectory !== undefined && (obj.registeredDirectory = message.registeredDirectory);
    message.commonName !== undefined && (obj.commonName = message.commonName);
    message.status !== undefined && (obj.status = verificationStateToJSON(message.status));
    message.message !== undefined && (obj.message = message.message);
    message.pkcs12password !== undefined && (obj.pkcs12password = message.pkcs12password);
    return obj;
  },

  create<I extends Exact<DeepPartial<RegisterReply>, I>>(base?: I): RegisterReply {
    return RegisterReply.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<RegisterReply>, I>>(object: I): RegisterReply {
    const message = createBaseRegisterReply();
    message.error = (object.error !== undefined && object.error !== null) ? Error.fromPartial(object.error) : undefined;
    message.id = object.id ?? "";
    message.registeredDirectory = object.registeredDirectory ?? "";
    message.commonName = object.commonName ?? "";
    message.status = object.status ?? 0;
    message.message = object.message ?? "";
    message.pkcs12password = object.pkcs12password ?? "";
    return message;
  },
};

function createBaseVerifyContactRequest(): VerifyContactRequest {
  return { id: "", token: "" };
}

export const VerifyContactRequest = {
  encode(message: VerifyContactRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.id !== "") {
      writer.uint32(10).string(message.id);
    }
    if (message.token !== "") {
      writer.uint32(18).string(message.token);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): VerifyContactRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseVerifyContactRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.id = reader.string();
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.token = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): VerifyContactRequest {
    return { id: isSet(object.id) ? String(object.id) : "", token: isSet(object.token) ? String(object.token) : "" };
  },

  toJSON(message: VerifyContactRequest): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    message.token !== undefined && (obj.token = message.token);
    return obj;
  },

  create<I extends Exact<DeepPartial<VerifyContactRequest>, I>>(base?: I): VerifyContactRequest {
    return VerifyContactRequest.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<VerifyContactRequest>, I>>(object: I): VerifyContactRequest {
    const message = createBaseVerifyContactRequest();
    message.id = object.id ?? "";
    message.token = object.token ?? "";
    return message;
  },
};

function createBaseVerifyContactReply(): VerifyContactReply {
  return { error: undefined, status: 0, message: "" };
}

export const VerifyContactReply = {
  encode(message: VerifyContactReply, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.error !== undefined) {
      Error.encode(message.error, writer.uint32(10).fork()).ldelim();
    }
    if (message.status !== 0) {
      writer.uint32(16).int32(message.status);
    }
    if (message.message !== "") {
      writer.uint32(26).string(message.message);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): VerifyContactReply {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseVerifyContactReply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.error = Error.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag != 16) {
            break;
          }

          message.status = reader.int32() as any;
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.message = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): VerifyContactReply {
    return {
      error: isSet(object.error) ? Error.fromJSON(object.error) : undefined,
      status: isSet(object.status) ? verificationStateFromJSON(object.status) : 0,
      message: isSet(object.message) ? String(object.message) : "",
    };
  },

  toJSON(message: VerifyContactReply): unknown {
    const obj: any = {};
    message.error !== undefined && (obj.error = message.error ? Error.toJSON(message.error) : undefined);
    message.status !== undefined && (obj.status = verificationStateToJSON(message.status));
    message.message !== undefined && (obj.message = message.message);
    return obj;
  },

  create<I extends Exact<DeepPartial<VerifyContactReply>, I>>(base?: I): VerifyContactReply {
    return VerifyContactReply.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<VerifyContactReply>, I>>(object: I): VerifyContactReply {
    const message = createBaseVerifyContactReply();
    message.error = (object.error !== undefined && object.error !== null) ? Error.fromPartial(object.error) : undefined;
    message.status = object.status ?? 0;
    message.message = object.message ?? "";
    return message;
  },
};

function createBaseVerificationRequest(): VerificationRequest {
  return { id: "", registeredDirectory: "", commonName: "" };
}

export const VerificationRequest = {
  encode(message: VerificationRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.id !== "") {
      writer.uint32(10).string(message.id);
    }
    if (message.registeredDirectory !== "") {
      writer.uint32(18).string(message.registeredDirectory);
    }
    if (message.commonName !== "") {
      writer.uint32(26).string(message.commonName);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): VerificationRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseVerificationRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.id = reader.string();
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.registeredDirectory = reader.string();
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.commonName = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): VerificationRequest {
    return {
      id: isSet(object.id) ? String(object.id) : "",
      registeredDirectory: isSet(object.registeredDirectory) ? String(object.registeredDirectory) : "",
      commonName: isSet(object.commonName) ? String(object.commonName) : "",
    };
  },

  toJSON(message: VerificationRequest): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    message.registeredDirectory !== undefined && (obj.registeredDirectory = message.registeredDirectory);
    message.commonName !== undefined && (obj.commonName = message.commonName);
    return obj;
  },

  create<I extends Exact<DeepPartial<VerificationRequest>, I>>(base?: I): VerificationRequest {
    return VerificationRequest.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<VerificationRequest>, I>>(object: I): VerificationRequest {
    const message = createBaseVerificationRequest();
    message.id = object.id ?? "";
    message.registeredDirectory = object.registeredDirectory ?? "";
    message.commonName = object.commonName ?? "";
    return message;
  },
};

function createBaseVerificationReply(): VerificationReply {
  return { verificationStatus: 0, serviceStatus: 0, verifiedOn: "", firstListed: "", lastUpdated: "", revokedOn: "" };
}

export const VerificationReply = {
  encode(message: VerificationReply, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.verificationStatus !== 0) {
      writer.uint32(8).int32(message.verificationStatus);
    }
    if (message.serviceStatus !== 0) {
      writer.uint32(16).int32(message.serviceStatus);
    }
    if (message.verifiedOn !== "") {
      writer.uint32(26).string(message.verifiedOn);
    }
    if (message.firstListed !== "") {
      writer.uint32(34).string(message.firstListed);
    }
    if (message.lastUpdated !== "") {
      writer.uint32(42).string(message.lastUpdated);
    }
    if (message.revokedOn !== "") {
      writer.uint32(50).string(message.revokedOn);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): VerificationReply {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseVerificationReply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 8) {
            break;
          }

          message.verificationStatus = reader.int32() as any;
          continue;
        case 2:
          if (tag != 16) {
            break;
          }

          message.serviceStatus = reader.int32() as any;
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.verifiedOn = reader.string();
          continue;
        case 4:
          if (tag != 34) {
            break;
          }

          message.firstListed = reader.string();
          continue;
        case 5:
          if (tag != 42) {
            break;
          }

          message.lastUpdated = reader.string();
          continue;
        case 6:
          if (tag != 50) {
            break;
          }

          message.revokedOn = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): VerificationReply {
    return {
      verificationStatus: isSet(object.verificationStatus) ? verificationStateFromJSON(object.verificationStatus) : 0,
      serviceStatus: isSet(object.serviceStatus) ? serviceStateFromJSON(object.serviceStatus) : 0,
      verifiedOn: isSet(object.verifiedOn) ? String(object.verifiedOn) : "",
      firstListed: isSet(object.firstListed) ? String(object.firstListed) : "",
      lastUpdated: isSet(object.lastUpdated) ? String(object.lastUpdated) : "",
      revokedOn: isSet(object.revokedOn) ? String(object.revokedOn) : "",
    };
  },

  toJSON(message: VerificationReply): unknown {
    const obj: any = {};
    message.verificationStatus !== undefined &&
      (obj.verificationStatus = verificationStateToJSON(message.verificationStatus));
    message.serviceStatus !== undefined && (obj.serviceStatus = serviceStateToJSON(message.serviceStatus));
    message.verifiedOn !== undefined && (obj.verifiedOn = message.verifiedOn);
    message.firstListed !== undefined && (obj.firstListed = message.firstListed);
    message.lastUpdated !== undefined && (obj.lastUpdated = message.lastUpdated);
    message.revokedOn !== undefined && (obj.revokedOn = message.revokedOn);
    return obj;
  },

  create<I extends Exact<DeepPartial<VerificationReply>, I>>(base?: I): VerificationReply {
    return VerificationReply.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<VerificationReply>, I>>(object: I): VerificationReply {
    const message = createBaseVerificationReply();
    message.verificationStatus = object.verificationStatus ?? 0;
    message.serviceStatus = object.serviceStatus ?? 0;
    message.verifiedOn = object.verifiedOn ?? "";
    message.firstListed = object.firstListed ?? "";
    message.lastUpdated = object.lastUpdated ?? "";
    message.revokedOn = object.revokedOn ?? "";
    return message;
  },
};

function createBaseHealthCheck(): HealthCheck {
  return { attempts: 0, lastCheckedAt: "" };
}

export const HealthCheck = {
  encode(message: HealthCheck, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.attempts !== 0) {
      writer.uint32(8).uint32(message.attempts);
    }
    if (message.lastCheckedAt !== "") {
      writer.uint32(18).string(message.lastCheckedAt);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): HealthCheck {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseHealthCheck();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 8) {
            break;
          }

          message.attempts = reader.uint32();
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.lastCheckedAt = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): HealthCheck {
    return {
      attempts: isSet(object.attempts) ? Number(object.attempts) : 0,
      lastCheckedAt: isSet(object.lastCheckedAt) ? String(object.lastCheckedAt) : "",
    };
  },

  toJSON(message: HealthCheck): unknown {
    const obj: any = {};
    message.attempts !== undefined && (obj.attempts = Math.round(message.attempts));
    message.lastCheckedAt !== undefined && (obj.lastCheckedAt = message.lastCheckedAt);
    return obj;
  },

  create<I extends Exact<DeepPartial<HealthCheck>, I>>(base?: I): HealthCheck {
    return HealthCheck.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<HealthCheck>, I>>(object: I): HealthCheck {
    const message = createBaseHealthCheck();
    message.attempts = object.attempts ?? 0;
    message.lastCheckedAt = object.lastCheckedAt ?? "";
    return message;
  },
};

function createBaseServiceState(): ServiceState {
  return { status: 0, notBefore: "", notAfter: "" };
}

export const ServiceState = {
  encode(message: ServiceState, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.status !== 0) {
      writer.uint32(8).int32(message.status);
    }
    if (message.notBefore !== "") {
      writer.uint32(18).string(message.notBefore);
    }
    if (message.notAfter !== "") {
      writer.uint32(26).string(message.notAfter);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): ServiceState {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseServiceState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 8) {
            break;
          }

          message.status = reader.int32() as any;
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.notBefore = reader.string();
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.notAfter = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): ServiceState {
    return {
      status: isSet(object.status) ? serviceState_StatusFromJSON(object.status) : 0,
      notBefore: isSet(object.notBefore) ? String(object.notBefore) : "",
      notAfter: isSet(object.notAfter) ? String(object.notAfter) : "",
    };
  },

  toJSON(message: ServiceState): unknown {
    const obj: any = {};
    message.status !== undefined && (obj.status = serviceState_StatusToJSON(message.status));
    message.notBefore !== undefined && (obj.notBefore = message.notBefore);
    message.notAfter !== undefined && (obj.notAfter = message.notAfter);
    return obj;
  },

  create<I extends Exact<DeepPartial<ServiceState>, I>>(base?: I): ServiceState {
    return ServiceState.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<ServiceState>, I>>(object: I): ServiceState {
    const message = createBaseServiceState();
    message.status = object.status ?? 0;
    message.notBefore = object.notBefore ?? "";
    message.notAfter = object.notAfter ?? "";
    return message;
  },
};

function createBaseError(): Error {
  return { code: 0, message: "" };
}

export const Error = {
  encode(message: Error, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.code !== 0) {
      writer.uint32(8).int32(message.code);
    }
    if (message.message !== "") {
      writer.uint32(18).string(message.message);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Error {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseError();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 8) {
            break;
          }

          message.code = reader.int32();
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.message = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Error {
    return {
      code: isSet(object.code) ? Number(object.code) : 0,
      message: isSet(object.message) ? String(object.message) : "",
    };
  },

  toJSON(message: Error): unknown {
    const obj: any = {};
    message.code !== undefined && (obj.code = Math.round(message.code));
    message.message !== undefined && (obj.message = message.message);
    return obj;
  },

  create<I extends Exact<DeepPartial<Error>, I>>(base?: I): Error {
    return Error.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<Error>, I>>(object: I): Error {
    const message = createBaseError();
    message.code = object.code ?? 0;
    message.message = object.message ?? "";
    return message;
  },
};

/**
 * The TRISADirectory service specifies how TRISA clients should interact with a
 * directory service to facilitate P2P transfers.
 */
export type TRISADirectoryService = typeof TRISADirectoryService;
export const TRISADirectoryService = {
  /**
   * Interactions with the Directory Service during a TRISA transfer
   * These are the primary Directory Service interactions.
   */
  lookup: {
    path: "/trisa.gds.api.v1beta1.TRISADirectory/Lookup",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: LookupRequest) => Buffer.from(LookupRequest.encode(value).finish()),
    requestDeserialize: (value: Buffer) => LookupRequest.decode(value),
    responseSerialize: (value: LookupReply) => Buffer.from(LookupReply.encode(value).finish()),
    responseDeserialize: (value: Buffer) => LookupReply.decode(value),
  },
  search: {
    path: "/trisa.gds.api.v1beta1.TRISADirectory/Search",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: SearchRequest) => Buffer.from(SearchRequest.encode(value).finish()),
    requestDeserialize: (value: Buffer) => SearchRequest.decode(value),
    responseSerialize: (value: SearchReply) => Buffer.from(SearchReply.encode(value).finish()),
    responseDeserialize: (value: Buffer) => SearchReply.decode(value),
  },
  /** Registration workflow and contact verification. */
  register: {
    path: "/trisa.gds.api.v1beta1.TRISADirectory/Register",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: RegisterRequest) => Buffer.from(RegisterRequest.encode(value).finish()),
    requestDeserialize: (value: Buffer) => RegisterRequest.decode(value),
    responseSerialize: (value: RegisterReply) => Buffer.from(RegisterReply.encode(value).finish()),
    responseDeserialize: (value: Buffer) => RegisterReply.decode(value),
  },
  verifyContact: {
    path: "/trisa.gds.api.v1beta1.TRISADirectory/VerifyContact",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: VerifyContactRequest) => Buffer.from(VerifyContactRequest.encode(value).finish()),
    requestDeserialize: (value: Buffer) => VerifyContactRequest.decode(value),
    responseSerialize: (value: VerifyContactReply) => Buffer.from(VerifyContactReply.encode(value).finish()),
    responseDeserialize: (value: Buffer) => VerifyContactReply.decode(value),
  },
  /** Supplies the entity review and TRISA verification status of a VASP */
  verification: {
    path: "/trisa.gds.api.v1beta1.TRISADirectory/Verification",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: VerificationRequest) => Buffer.from(VerificationRequest.encode(value).finish()),
    requestDeserialize: (value: Buffer) => VerificationRequest.decode(value),
    responseSerialize: (value: VerificationReply) => Buffer.from(VerificationReply.encode(value).finish()),
    responseDeserialize: (value: Buffer) => VerificationReply.decode(value),
  },
  /** Health check and status request that mirrors the TRISAHealth service */
  status: {
    path: "/trisa.gds.api.v1beta1.TRISADirectory/Status",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: HealthCheck) => Buffer.from(HealthCheck.encode(value).finish()),
    requestDeserialize: (value: Buffer) => HealthCheck.decode(value),
    responseSerialize: (value: ServiceState) => Buffer.from(ServiceState.encode(value).finish()),
    responseDeserialize: (value: Buffer) => ServiceState.decode(value),
  },
} as const;

export interface TRISADirectoryServer extends UntypedServiceImplementation {
  /**
   * Interactions with the Directory Service during a TRISA transfer
   * These are the primary Directory Service interactions.
   */
  lookup: handleUnaryCall<LookupRequest, LookupReply>;
  search: handleUnaryCall<SearchRequest, SearchReply>;
  /** Registration workflow and contact verification. */
  register: handleUnaryCall<RegisterRequest, RegisterReply>;
  verifyContact: handleUnaryCall<VerifyContactRequest, VerifyContactReply>;
  /** Supplies the entity review and TRISA verification status of a VASP */
  verification: handleUnaryCall<VerificationRequest, VerificationReply>;
  /** Health check and status request that mirrors the TRISAHealth service */
  status: handleUnaryCall<HealthCheck, ServiceState>;
}

export interface TRISADirectoryClient extends Client {
  /**
   * Interactions with the Directory Service during a TRISA transfer
   * These are the primary Directory Service interactions.
   */
  lookup(
    request: LookupRequest,
    callback: (error: ServiceError | null, response: LookupReply) => void,
  ): ClientUnaryCall;
  lookup(
    request: LookupRequest,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: LookupReply) => void,
  ): ClientUnaryCall;
  lookup(
    request: LookupRequest,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: LookupReply) => void,
  ): ClientUnaryCall;
  search(
    request: SearchRequest,
    callback: (error: ServiceError | null, response: SearchReply) => void,
  ): ClientUnaryCall;
  search(
    request: SearchRequest,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: SearchReply) => void,
  ): ClientUnaryCall;
  search(
    request: SearchRequest,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: SearchReply) => void,
  ): ClientUnaryCall;
  /** Registration workflow and contact verification. */
  register(
    request: RegisterRequest,
    callback: (error: ServiceError | null, response: RegisterReply) => void,
  ): ClientUnaryCall;
  register(
    request: RegisterRequest,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: RegisterReply) => void,
  ): ClientUnaryCall;
  register(
    request: RegisterRequest,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: RegisterReply) => void,
  ): ClientUnaryCall;
  verifyContact(
    request: VerifyContactRequest,
    callback: (error: ServiceError | null, response: VerifyContactReply) => void,
  ): ClientUnaryCall;
  verifyContact(
    request: VerifyContactRequest,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: VerifyContactReply) => void,
  ): ClientUnaryCall;
  verifyContact(
    request: VerifyContactRequest,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: VerifyContactReply) => void,
  ): ClientUnaryCall;
  /** Supplies the entity review and TRISA verification status of a VASP */
  verification(
    request: VerificationRequest,
    callback: (error: ServiceError | null, response: VerificationReply) => void,
  ): ClientUnaryCall;
  verification(
    request: VerificationRequest,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: VerificationReply) => void,
  ): ClientUnaryCall;
  verification(
    request: VerificationRequest,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: VerificationReply) => void,
  ): ClientUnaryCall;
  /** Health check and status request that mirrors the TRISAHealth service */
  status(request: HealthCheck, callback: (error: ServiceError | null, response: ServiceState) => void): ClientUnaryCall;
  status(
    request: HealthCheck,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: ServiceState) => void,
  ): ClientUnaryCall;
  status(
    request: HealthCheck,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: ServiceState) => void,
  ): ClientUnaryCall;
}

export const TRISADirectoryClient = makeGenericClientConstructor(
  TRISADirectoryService,
  "trisa.gds.api.v1beta1.TRISADirectory",
) as unknown as {
  new (address: string, credentials: ChannelCredentials, options?: Partial<ClientOptions>): TRISADirectoryClient;
  service: typeof TRISADirectoryService;
};

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P
  : P & { [K in keyof P]: Exact<P[K], I[K]> } & { [K in Exclude<keyof I, KeysOfUnion<P>>]: never };

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
